AMPS C/C++ Client Class Reference AMPS C/C++ Client Version 5.3.5.7

Public Member Functions | List of all members
AMPS::BookmarkStore Class Reference
Special Bookmark Values

Interface for BookmarkStoreImpl classes. More...

`#include <BookmarkStore.hpp>`

## Public Member Functions
| BookmarkStore ()=default
| Creates a BookmarkStore that does nothing.
| BookmarkStore (BookmarkStoreImpl *impl_)
| Creates a BookmarkStore based on the given implementation.
void | setImplementation (BookmarkStoreImpl *impl_)
| Sets the BookmarkStore to use the given implementation.
size_t | log (Message &message_)
| Log a bookmark to the persistent log. More...
void | discard (const Message::Field &subId_, size_t bookmarkSeqNo_)
| Log a discard-bookmark entry to the persistent log based on a bookmark sequence number. More...
void | discard (const Message &message_)
| Log a discard-bookmark entry to the persistent log based on a Message. More...
Message::Field | getMostRecent (const Message::Field &subId_)
| Returns the most recent bookmark from the log that ought to be used for (re-)subscriptions. More...
bool | isDiscarded (Message &message_)
| Called for each arriving message to determine if the application has already seen this bookmark and should not be reprocessed. More...
void | purge ()
| Called to purge the contents of this store. More...
void | purge (const Message::Field &subId_)
| Called to purge the contents of this store for particular subId. More...
void | setResizeHandler (BookmarkStoreResizeHandler handler_, void *userData_)
| Set a handler on the bookmark store that will get called whenever a resize of the store is required due to the number of stored bookmarks exceeding the currently allocated storage to hold them. More...
size_t | getOldestBookmarkSeq (const std::string &subId_)
| Called to find the oldest bookmark in the store. More...
size_t | getOldestBookmarkSeq (const Message::Field &subId_)
| Called to find the oldest bookmark sequence in the store. More...
void | persisted (const Message::Field &subId_, const Message::Field &bookmark_)
| Called internally to indicate messages up to and including bookmark are replicated to all replication destinations. More...
void | persisted (const Message::Field &subId_, size_t bookmark_)
| Called internally to indicate messages up to and including bookmark are replicated to all replication destinations. More...
void | setServerVersion (size_t version_)
| Internally used to set the server version so the store knows how to deal with persisted acks and calls to getMostRecent(). More...
void | setServerVersion (const VersionInfo &version_)
| Internally used to set the server version so the store knows how to deal with persisted acks and calls to getMostRecent(). More...
void | prune (const std::string &tmpFileName_="")
| Used to trim the size of a store's storage. More...
BookmarkStoreImpl * | get ()
| Used to get a pointer to the implementation. More...
size_t | getMaxSubIdLength () const
| Gets the maximum allowed length for a sub id when recovering a bookmark store from persistent storage. More...
void | setMaxSubIdLength (size_t maxSubIdLength_)
| Sets the maximum allowed length for a sub id when recovering a bookmark store from persistent storage. More...

## Detailed Description

Interface for BookmarkStoreImpl classes.

The documentation for this class was generated from the following file:

- include/amps/BookmarkStore.hpp